#!/usr/bin/env ruby
###########################################################################
###########################################################################
##  Copyright The Resistance (C) 1995-2011                               ##
##  Author: blass                                                        ##
##  blass[at]sdf.lonestar.org                                            ##
##  Badass 0.2 Beta                                                      ##
##  This file is part of Badass.                                         ##
##  Badass is free software: you can redistribute it and/or modify       ##
##  it under the terms of the GNU General Public License as published by ##
##  the Free Software Foundation, either version 3 of the License, or    ##
##  (at your option) any later version.                                  ##
##  Badass is distributed in the hope that it will be useful,            ##
##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
##  GNU General Public License for more details.                         ##
##  You should have received a copy of the GNU General Public License    ##
##  along with Badass. If not, see http://www.gnu.org/licenses/          ##
###########################################################################
###########################################################################

module Racket
  module L2
    # Logical Link Control (http://en.wikipedia.org/wiki/Logical_Link_Control)
    class LLC < RacketPart
      LLC_IBM_SNA = 0x04 
      LLC_IP = 0x06
      LLC_3COM = 0x80
      LLC_SNAP = 0xAA
      LLC_BANYAN = 0xBC
      LLC_NOVELL = 0xE0
      LLC_LANMAN = 0xF4
      # Destination Service Access Point address
      unsigned :dsap, 8, { :default => 0xaa }
      # Source Service Access Point address
      unsigned :ssap, 8, { :default => 0xaa }
      # Control field
      unsigned :control, 8
      # Payload
      rest :payload
    end
  end
end
# vim: set ts=2 et sw=2:
