#!/usr/bin/env ruby
###########################################################################
###########################################################################
##  Copyright The Resistance (C) 1995-2011                               ##
##  Author: blass                                                        ##
##  blass[at]sdf.lonestar.org                                            ##
##  Badass 0.2 Beta                                                      ##
##  This file is part of Badass.                                         ##
##  Badass is free software: you can redistribute it and/or modify       ##
##  it under the terms of the GNU General Public License as published by ##
##  the Free Software Foundation, either version 3 of the License, or    ##
##  (at your option) any later version.                                  ##
##  Badass is distributed in the hope that it will be useful,            ##
##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
##  GNU General Public License for more details.                         ##
##  You should have received a copy of the GNU General Public License    ##
##  along with Badass. If not, see http://www.gnu.org/licenses/          ##
###########################################################################
###########################################################################

#require 'rubygems'
require File.dirname(__FILE__) + '/../../bit-struct/bit-struct.rb'

module Racket
  # Every Racket object is made up of numerous sub-parts, namely layers of the OSI stack.
  class RacketPart < BitStruct
    
    # Boolean indicating whether or not this instance should be
    # automatically "fixed" prior to be packed and sent.
    attr_accessor :autofix
    
    # Should this instance be automatically fixed 
    # prior to being packed and sent?
    def autofix?
      @autofix
    end
    
    def initialize(*args)
      @autofix = true
      super(*args)
    end
    
    
    # Print out all of the fields and all of their values
    def pretty
      s  = ""
      self.fields.each do |f|
        unless (f.name == "payload")
          s += "#{f.name}=#{self.send(f.name)} "
        end
      end
      s.gsub(/ $/, '')
    end
    
    def fix!
    end
  end
end
# vim: set ts=2 et sw=2:
